#ifndef _fencer_debug_h
#define _fencer_debug_h

#include <stdio.h>

extern int g_debug_error_abort;

#define LOG_INFO(...) do {\
    printf("[%s:%d]  INFO | ", __FILE__, __LINE__);\
    printf(__VA_ARGS__);\
    printf("\n");\
} while(0)

#define LOG_ERROR(...) do {\
    printf("[%s:%d]  ERROR | ", __FILE__, __LINE__);\
    printf(__VA_ARGS__);\
    printf("\n");\
    fflush(stdout);\
    if(g_debug_error_abort != 0) abort();\
} while(0)

#define LOG_WARNING(...) do {\
    printf("[%s:%d]  WARNING | ", __FILE__, __LINE__);\
    printf(__VA_ARGS__);\
    printf("\n");\
} while(0)


#define RETURN_ERROR(__VALUE, ...) do {\
    LOG_ERROR(__VA_ARGS__);\
    return __VALUE;\
} while(0)

#define RETURN_WARNING(__VALUE, ...) do {\
    LOG_WARNING(__VA_ARGS__);\
    return __VALUE;\
} while(0)

#define ASSERT_RETURN(__ASSERT, __RETURN, ...) do {\
    if(!(__ASSERT)) {\
        LOG_ERROR(__VA_ARGS__);\
        return __RETURN;\
    }\
} while(0)

#define ASSERT_RETURN_WARN(__ASSERT, __RETURN, ...) do {\
    if(!(__ASSERT)) {\
        LOG_WARNING(__VA_ARGS__);\
        return __RETURN;\
    }\
} while(0)

#endif // !_fencer_debug_h
