#ifndef _fencer_rigidbody_h
#define _fencer_rigidbody_h

#include "shape.h"
#include "transformable.h"
#include "list.h"

struct Collision;

typedef struct RigidBody RigidBody;

// Referenced transform is stored but not owned by the rigidbody.
RigidBody* rigidbody_make(Transformable transform);
void rigidbody_destroy(RigidBody* self);

void rigidbody_add_contact(RigidBody* self, struct Collision hit);
void rigidbody_solve_contacts(RigidBody* self);

void rigidbody_apply_physics(RigidBody* self);

float rigidbody_get_mass(const RigidBody* self);
void rigidbody_set_mass(RigidBody* self, float mass);

void rigidbody_add_impulse(RigidBody* self, Vector force);
void rigidbody_accelerate(RigidBody* self, Vector force);

int rigidbody_is_static(const RigidBody* self);
void rigidbody_set_static(RigidBody* self, int is_static);

Vector rigidbody_get_velocity(const RigidBody* self);
void rigidbody_set_velocity(RigidBody* self, Vector velocity);

#endif // !_fencer_rigidbody_h
